'// Spy_Not tool to read the public spyware domain list and create an IPAD compatible BOOT.NAM include file
'// Created 2006 by Casey Sprangel
'// Written in PowerBasic CC 4.0 (www.powerbasic.com)
'//---------------------------------------------------------------------------
'// Things to add:
'// + Ability to detect version or file date change and only download when new
'//---------------------------------------------------------------------------
#COMPILE EXE                                                      '// make into a stand-alone program
#DIM ALL                                                          '// force a declare for everything we use
'//---------------------------------------------------------------------------
$version = "20070710"
$title = "SPY_NOT"
$myfile = "spywaredomains.zones"                                  '// default input file name

'//---------------------------------------------------------------------------
DECLARE FUNCTION getfile(s AS STRING) AS STRING
DECLARE FUNCTION URLDownloadToFile LIB "urlmon.dll" ALIAS "URLDownloadToFileA" (BYVAL pCaller AS LONG, szURL AS ASCIIZ, szFileName AS ASCIIZ, BYVAL dwReserved AS LONG, BYVAL lpfnCB AS LONG) AS LONG
DECLARE FUNCTION DownloadFile(URL AS ASCIIZ, LocalFilename AS ASCIIZ) AS LONG

'//---------------------------------------------------------------------------
FUNCTION DownloadFile(URL AS ASCIIZ, LocalFilename AS ASCIIZ) AS LONG '// Download a file from a web server
  DIM lngRetVal AS LONG                                           '// return value
  lngRetVal = URLDownloadToFile(0, URL, LocalFilename, 0, 0)      '// cheat and call IE to do our dirty work (should be internal chunked HTTP)
  IF lngRetVal = 0 THEN                                           '// no error?
    FUNCTION = 1                                                  '// return success
  END IF
END FUNCTION

'//---------------------------------------------------------------------------
FUNCTION getfile(s AS STRING) AS STRING                           '// get the master file
  LOCAL buf AS STRING                                             '// local string buffer
  LOCAL h AS LONG                                                 '// local file handle
  LOCAL i AS LONG                                                 '// local offset pointer

  IF DIR$($myfile) = "" THEN                                      '// local file not found?
    STDOUT "Attempting to download a new master file... ";        '// leave line open for continuation
    IF DownloadFile(s + $NUL, $myfile + $NUL) = 1 THEN            '// download the file from the web server
      STDOUT "Success!"                                           '// good news
    ELSE
      STDOUT "Failed!"                                            '// bad news
    END IF
  END IF
  IF DIR$($myfile) > "" THEN                                      '// local file is found?
    h = FREEFILE                                                  '// get next available file handle
    OPEN $myfile FOR BINARY AS h                                  '// open the local input file
    i = LOF(h)                                                    '// get the total file size
    IF i = 0 THEN                                                 '// is this an empty file?
      STDOUT "Error reading " + $myfile                           '// tell user we could not read the local file
      CLOSE h                                                     '// release the file handle
      KILL $myfile                                                '// erase the empty file
      EXIT FUNCTION                                               '// leave, we can't do anything else
    END IF
    GET$ #h, i, buf                                               '// get the whole file in one chunk (memory hog, but fast)
    CLOSE h                                                       '// release the file handle
    REPLACE "type master; file ""/etc/namedb/blockeddomain.hosts"";" WITH "" IN buf '// remove the parts we don't need (for faster parsing)
  ELSE                                                            '// local file not found
    STDOUT "Local copy of master file (" + $myfile + ") not found."
    STDOUT "Unable to download new master file from web site. Are we online?"
  END IF                                                          '// local file found?
  FUNCTION = buf                                                  '// return what we found
END FUNCTION

'//---------------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG                                        '// program starts here
  DIM buf AS STRING                                               '// master buffer (holds whole input file)
  DIM w AS STRING                                                 '// line of text for working
  DIM s AS STRING                                                 '// source site address
  DIM o AS STRING                                                 '// output file name
  DIM i AS LONG                                                   '// pointer
  DIM h AS LONG                                                   '// output file handle
  DIM x AS STRING * 1                                             '// detect if time changed (one byte)
  DIM tcount AS LONG                                              '// total line count to process
  DIM lcount AS LONG                                              '// lines that we have processed
  DIM bpoint AS LONG

  s = "http://www.bleedingsnort.com/blackhole-dns/files/spywaredomains.zones" '// master list source
  o = "SPY_NOT.INC"                                               '// default output file name
  CONSOLE NAME $title
  STDOUT $title + " Tool [" + $version + "]"                      '// show our version info
  buf = COMMAND$                                                  '// get the command line
  IF INSTR(buf, ANY "*?") > 0 THEN                                '// did user ask for help (any wildcard character will do)
    STDOUT "This tool will download the latest list of spyware web sites"
    STDOUT "and create a list compatible with the IPAD DNS server."
    STDOUT ""
    STDOUT "Syntax: SPY_NOT [<filename>]
    STDOUT " Filename is the name of the output file. If not given, the"
    STDOUT " default name is " + o + " in the current directory."
    EXIT FUNCTION
  END IF
  IF buf > "" THEN                                                '// did user provide a filename?
    o = buf                                                       '// use this for our output filename
  END IF
  STDOUT "Reading: " + s                                          '// show source name
  STDOUT "Writing: " + o                                          '// show output name
  buf = TRIM$(getfile(s), ANY $SPC + $CRLF)                       '// get the raw input file with no leading or trailing whitespace or end of line markers
  REPLACE $TAB WITH $SPC IN buf                                   '// all tabs become spaces
  REPLACE "  " WITH $SPC IN buf                                   '// double spaces become single spaces for easier parsing
  IF INSTR(buf, $LF) > 0 AND INSTR(buf, $CR) = 0 THEN             '// line feeds with no carraige returns (UNIX format)?
    REPLACE $LF WITH $CRLF IN buf                                 '// replace all of the line feeds with full crlf pairs (Microsoft format)
  END IF
  buf = buf + $CRLF                                               '// add a trailing end of line for easier parsing
  tcount = TALLY(buf, $CR)                                        '// count the total number of lines
  STDOUT "Processing " + FORMAT$(LEN(buf)) + " bytes, " + FORMAT$(tcount,"#,") + " lines."
  h = FREEFILE                                                    '// get next available file handle
  OPEN o FOR OUTPUT AS h                                          '// open output file (create/overwrite)
  PRINT #h, "# Translated to IPAD format on " + RIGHT$(DATE$,4) + LEFT$(DATE$,2) + MID$(DATE$,4,2) + " " + TIME$ + " by " + $title + $SPC + $version + "." + $CRLF + "# Source: " + s
  bpoint = 1                                                      '// start reading at the first character of our buffer
  DO WHILE bpoint > 0                                             '// loop until the buffer is empty
    i = INSTR(bpoint, buf, $CRLF)                                 '// find offset to end of line or end of buffer
    IF i = 0 THEN                                                 '// did we reach the end of our buffer?
      EXIT LOOP                                                   '// leave, we are done
    END IF
    w = MID$(buf, bpoint, i - 1)                                  '// get the line
    bpoint = i + 2                                                '// remember the end of this line (start of next line)
    INCR lcount                                                   '// add one to our line counter
    IF LEN(TRIM$(w)) > 0 THEN                                     '// not blank?
      IF LCASE$(LEFT$(w,5)) = "zone " THEN                        '// not a comment line?
        w = TRIM$(PARSE$(w, $SPC, 2), $DQ)                        '// get the second parameter (the zone)
      END IF                                                      '// is this a comment line?
    END IF
    IF LEN(w) > 0 THEN                                            '// only write lines with something to say
      w = TRIM$(w, ".") + "."                                     '// make sure this domain is fully qualified
      SELECT CASE LEN(w) \ 8                                      '// find the length of the name in 8 character chunks (integer div)
        CASE 0                                                    '// less than 8 characters
          w = w + $TAB + $TAB + $TAB + $TAB
        CASE 1                                                    '// at least 8 characters and less than 16
          w = w + $TAB + $TAB + $TAB
        CASE 2                                                    '// at least 16 characters and less than 24
          w = w + $TAB + $TAB
        CASE 3                                                    '// more than 24 characters and less than 32
          w = w + $TAB
        CASE ELSE                                                 '// more than 32 characters
          w = w + $SPC
      END SELECT
      PRINT #h, "PRIMARY " + w + "BLAKHOLE.NAM"                   '// write the line to the output file
    END IF
    IF x <> RIGHT$(TIME$,1) THEN                                  '// did the time change?
      CONSOLE NAME $title + " [" + FORMAT$(tcount - lcount, "#,") + "]" '// show progress on the title bar
      x = RIGHT$(TIME$,1)                                         '// remember this second so we don't repeat too often
    END IF
  LOOP
  CLOSE h                                                         '// release the file handle to flush all buffers
  STDOUT "Done."                                                  '// tell user we are done
END FUNCTION
